Programs

dbmmanage

is used to create and update the DBM format files used to store
usernames and password for basic authentication of HTTP users via

mod\_authn\_dbm

. Resources available from the Apache HTTP server can be restricted to
just the users listed in the files created by

dbmmanage

. This program can only be used when the usernames are stored in a DBM
file. To use a flat-file database see

htpasswd

.

Another tool to maintain a DBM password database is

htdbm

.

This manual page only lists the command line arguments. For details of
the directives necessary to configure user authentication in

httpd

see the httpd manual, which is part of the Apache distribution or can be
found at

http://httpd.apache.org/

.

httpd

htdbm

mod\_authn\_dbm

mod\_authz\_dbm

Synopsis
========

dbmmanage

\[

encoding

\]

filename

add\|adduser\|check\|delete\|update

username

\[

encpasswd

\[

group

\[,

group

\...\] \[

comment

\] \] \]

dbmmanage

filename

view \[

username

\]

dbmmanage

filename

import

Options
=======

filename

The filename of the DBM format file. Usually without the extension

.db

,

.pag

, or

.dir

.

username

The user for which the operations are performed. The

username

may not contain a colon (

:

).

encpasswd

This is the already hashed password to use for the

update

and

add

commands. You may use a hyphen (

\-

) if you want to get prompted for the password, but fill in the fields
afterwards. Additionally when using the

update

command, a period (

.

) keeps the original password untouched.

group

A group, which the user is member of. A groupname may not contain a
colon (

:

). You may use a hyphen (

\-

) if you don\'t want to assign the user to a group, but fill in the
comment field. Additionally when using the

update

command, a period (

.

) keeps the original groups untouched.

comment

This is the place for your opaque comments about the user, like
realname, mailaddress or such things. The server will ignore this field.

Encodings {#options.encodings}
---------

-d

crypt hashing (default, except on Win32, Netware)

-m

MD5 hashing (default on Win32, Netware)

-s

SHA1 hashing

-p

plaintext (

not recommended

)

Commands {#options.commands}
--------

add

Adds an entry for

username

to

filename

using the hashed password

encpasswd

.

dbmmanage passwords.dat add rbowen foKntnEF3KSXA

adduser

Asks for a password and then adds an entry for

username

to

filename

.

dbmmanage passwords.dat adduser krietz

check

Asks for a password and then checks if

username

is in

filename

and if it\'s password matches the specified one.

dbmmanage passwords.dat check rbowen

delete

Deletes the

username

entry from

filename

.

dbmmanage passwords.dat delete rbowen

import

Reads

username

:

password

entries (one per line) from

STDIN

and adds them to

filename

. The passwords already have to be crypted.

update

Same as the

adduser

command, except that it makes sure

username

already exists in

filename

.

dbmmanage passwords.dat update rbowen

view

Just displays the contents of the DBM file. If you specify a

username

, it displays the particular record only.

dbmmanage passwords.dat view

Bugs
====

One should be aware that there are a number of different DBM file
formats in existence, and with all likelihood, libraries for more than
one format may exist on your system. The three primary examples are
SDBM, NDBM, the GNU project\'s GDBM, and Berkeley DB 2. Unfortunately,
all these libraries use different file formats, and you must make sure
that the file format used by

filename

is the same format that

dbmmanage

expects to see.

dbmmanage

currently has no way of determining what type of DBM file it is looking
at. If used against the wrong format, will simply return nothing, or may
create a different DBM file with a different name, or at worst, it may
corrupt the DBM file if you were attempting to write to it.

dbmmanage

has a list of DBM format preferences, defined by the

@AnyDBM::ISA

array near the beginning of the program. Since we prefer the Berkeley DB
2 file format, the order in which

dbmmanage

will look for system libraries is Berkeley DB 2, then NDBM, then GDBM
and then SDBM. The first library found will be the library

dbmmanage

will attempt to use for all DBM file transactions. This ordering is
slightly different than the standard

@AnyDBM::ISA

ordering in Perl, as well as the ordering used by the simple

dbmopen()

call in Perl, so if you use any other utilities to manage your DBM
files, they must also follow this preference ordering. Similar care must
be taken if using programs in other languages, like C, to access these
files.

One can usually use the

file

program supplied with most Unix systems to see what format a DBM file is
in.
