mod\_rewrite

provides a way to modify incoming URL requests, dynamically, based on

regular expression

rules. This allows you to map arbitrary URLs onto your internal URL
structure in any way you like.

It supports an unlimited number of rules and an unlimited number of
attached rule conditions for each rule to provide a really flexible and
powerful URL manipulation mechanism. The URL manipulations can depend on
various tests: server variables, environment variables, HTTP headers,
time stamps, external database lookups, and various other external
programs or handlers, can be used to achieve granular URL matching.

Rewrite rules can operate on the full URLs, including the path-info and
query string portions, and may be used in per-server context (

httpd.conf

), per-virtualhost context (

VirtualHost

blocks), or per-directory context (

.htaccess

files and

Directory

blocks). The rewritten result can lead to further rules, internal
sub-processing, external request redirection, or proxy passthrough,
depending on what

flags

you attach to the rules.

Since mod\_rewrite is so powerful, it can indeed be rather complex. This
document supplements the

reference documentation

, and attempts to allay some of that complexity, and provide highly
annotated examples of common scenarios that you may handle with
mod\_rewrite. But we also attempt to show you when you should not use
mod\_rewrite, and use other standard Apache features instead, thus
avoiding this unnecessary complexity.

mod\_rewrite reference documentation

Introduction to regular expressions and mod\_rewrite

RewriteRule Flags

Using RewriteMap

When

NOT

to use mod\_rewrite

Using mod\_rewrite for redirection and remapping of URLs

Using mod\_rewrite to control access

Dynamic virtual hosts with mod\_rewrite

Dynamic proxying with mod\_rewrite

Advanced techniques

Technical details

mod\_rewrite reference documentation

Mapping URLs to the Filesystem

mod\_rewrite wiki

Glossary
